;
;       Art Studio Picture Format Support Library (Slideshow Version)
;
artstd_beginview        jsr artstd_wipecols
                        jsr artstd_setupirq
                        lda #1
                        sta artstd_mode
                        rts

artstd_beginhide        jsr artstd_setupirq
                        lda #2
                        sta artstd_mode
                        rts

artstd_beginstop        lda #0
                        sta artstd_mode
                        rts

artstd_wait             lda #0
                        ldx #2
artstd_wait_l1          cmp artstd_vapart
                        bne artstd_wait_l1
                        dex
                        bne artstd_wait_l1
                        rts


artstd_wipecols         ldx #0
                        txa
artstd_wipecols_l1      sta $0400,x
                        sta $0500,x
                        sta $0600,x
                        sta $0700,x
                        sta $d800,x
                        sta $d900,x
                        sta $da00,x
                        sta $db00,x
                        inx
                        bne artstd_wipecols_l1
                        rts

artstd_setupirq         nop
                        sei
                        lda #<artstd_irq
                        ldx #>artstd_irq
                        sta $0314
                        stx $0315
                        lda #1
                        sta $d01a
                        sta $dc0d
                        lda $d011
                        and #$7f
                        sta $d011
                        lda #0
                        sta $d012
                        sta artstd_vapart+1
                        cli
                        rts

artstd_irq              nop
                        lda artstd_play1003
                        beq artstd_irq_l1
                        jsr playifavailable
artstd_irq_l1           nop

                        lda artstd_mode
                        cmp #1
                        bne artstd_nshow
                        jsr artstd_vapart
artstd_nshow            lda artstd_mode
                        cmp #2
                        bne artstd_nhide
                        jsr artstd_hapart
artstd_nhide            nop

                        inc $d019
                        jmp $ea7e


artstd_mode             .byte 0 ; Mode 1 = SHOW
                                ; Mode 2 = HIDE

artstd_vapart           ldx #0 ; View apart of picture

                        inc artstd_vapart+1

                        lda $3f40,x
                        sta $0400,x
                        lda $4040,x
                        sta $0500,x
                        lda $4140,x
                        sta $0600,x

                        lda $4338,x
                        sta $d800,x
                        lda $4438,x
                        sta $d900,x
                        lda $4538,x
                        sta $da00,x

                        cpx #$e8
                        bcc artstd_vapart_l1
                        lda $4240,x
                        sta $0700,x
                        lda $4638,x
                        sta $db00,x
artstd_vapart_l1        rts


artstd_hapart           ldx artstd_vapart+1
                        inc artstd_vapart+1
                        lda #0
                        sta $0400,x
                        sta $0500,x
                        sta $0600,x
                        sta $d800,x
                        sta $d900,x
                        sta $da00,x
                        cpx #$e8
                        bcc artstd_hapart_l1
                        sta $0700,x
                        sta $db00,x
artstd_hapart_l1        rts
