;
;       Unique graphics library
;
;               for the 320x200 16C interlaced graphics mode.
;
;       Usable functions:
;
;               gl320200_viewmode
;

; Bitmap #1 at $2000-$3f40
; Bitmap #2 at $6000-$7f40
; Screen #1 at $0400-$07e8 (Temporarily located at $4000-$43e8)
; Screen #2 at $4400-$47e8
; Global colors at $d800-$dbe8 (Temporarily located at $4800-$4be8)
;
gl320200_interlacer     ;
gl320200_dd00           lda #$97
                        eor #1
                        sta gl320200_dd00+1
                        sta $dd00
gl320200_d016           lda #$d8
                        eor #1
                        sta gl320200_d016+1
                        sta $d016
                        ;
                        lda $1003
                        cmp #$4c ; JMP opcode at $1003 ? Yes = Call $1003
                        bne gl320200_interlacer_l1
                        jsr $1003
gl320200_interlacer_l1  inc $d019
                        jmp $ea7e

gl320200_irq            call gl320200_interlacer

gl320200_viewmode       jsr gl320200_hz50 ; Requires own interrupt handler!
                        lda #$0b
                        sta $d011
                        sei
                        lda #<gl320200_irq
                        ldx #>gl320200_irq
                        sta $0314
                        stx $0315
                        lda #1
                        sta $d01a
                        sta $dc0d
                        lda $d011
                        and #$7f
                        sta $d011
                        lda #0
                        sta $d012
                        cli
                        lda #$19
                        sta $d018
                        lda #$d8
                        sta $d016
                        lda $dd00
                        ora #3
                        sta $dd00
gl320200_viewmode_bc    lda #0    ; <- side Border Color
                        sta $d020
gl320200_viewmode_bg    lda #0    ; <- BackGround color
                        sta $d021 
                        ldx #0
gl320200_viewmode_l1    lda $4000,x ; $4000 to $0400
                        sta $0400,x
                        lda $4100,x
                        sta $0500,x
                        lda $4200,x
                        sta $0600,x
                        lda $4300,x
                        sta $0700,x
                        lda $4800,x ; $4800 to $d800
                        sta $d800,x
                        lda $4900,x
                        sta $d900,x
                        lda $4a00,x
                        sta $da00,x
                        lda $4b00,x
                        sta $db00,x                        
                        inx
                        bne gl320200_viewmode_l1
                        jsr hz50
                        lda #$3b
                        sta $d011
                        rts

gl320200_hz50           lda #$ff
gl320200_hz50_l1        cmp $d012
                        bne gl320200_hz50_l1
                        rts
