;
; ILOAD & Execute 
;
; This routine loads executable file using Dow Jones irq-loader,
; after loading it setups safemode interrupt and checks if
; the loaded code is "GOOD" code, if it is then it
; executes the code which is possible to execute, and which is fully legal.
;

iexecute_hz50   lda #$ff
iexecute_hz50_l1 cmp $d012
                bne iexecute_hz50_l1
                rts

iexecute        jsr iexecute_hz50
                ldx #$2f
iexecute_l1     lda iexecute_ih02a7,x
                sta $02a7,x
                lda iexecute_lc0334,x
                sta $0334,x
                dex
                bpl iexecute_l1
                                  ; Irq handler at $02a7 (JTT stylish)
                sei               ; LDR caller at $0334
                lda #<$02a7
                ldx #>$02a7
                sta $0314
                stx $0315
                lda #1
                sta $d01a
                sta $dc0d
                lda $d011
                and #$7f
                sta $d011
                lda #0
                sta $d012
                cli
                jmp $0334

iexecute_lc0334 jsr $c000
                lda $0800
                sta $30
                lda $0801
                sta $31
                ldy #0
                lda ($30),y             ; JMP opcode must be included in 
                cmp #$4c                ; beginning of every legal
                bne iexecute_sererr     ; Unique / JTT system executable file.
                jmp ($0800)
iexecute_sererr sei
                lda #$37
                sta 1
                jmp ($fffc)

iexecute_ih02a7 lda $1003
                cmp #$4c ; JMP opcode at address $1003 ? Yes = Play music/What ever
                bne iexecute_nplay
                jsr $1003
iexecute_nplay  nop
                inc $d019
                jmp $ea7e

iexecute_load   lda r0
                ldx r0+1
                sta $30
                stx $31
                ldy #0
                lda ($30),y
                tax
                iny
                lda ($30),y
                tay
                jmp $c200

playifavailable lda $1003
                cmp #$4c
                bne playifavailablel
                jsr $1003
playifavailablel rts

initmusic       lda #0
                tax
                tay
                jmp $1000

nosound         ldx #0
                txa
nosoundl1       sta $d400,x
                inx
                cpx #$19
                bne nosoundl1
                rts
