;----------------------------------------------------------------------------
;
;       JTT programming language REU support library
;       provides access to Ram Expansion Unit memory 
;       when using JTT.
;       (C)1998 by Jari Tapio Tuominen, all rights reserved.
;
;----------------------------------------------------------------------------

reu_status   = $DF00
reu_command  = $DF01
reu_c64base  = $DF02
reu_reubase  = $DF04
reu_translen = $DF07
reu_irqmask  = $DF09
reu_control  = $DF0A


;----------------------------------------------------------------------------
;
;       moveramtoreu
;       ------------
;
;       Usage:
;
;       moveramtoreu( offsetreu offsetram length );
;
;       See: movereutoram
;
;----------------------------------------------------------------------------
moveramtoreu    lda #0
                sta reu_control ; to make sure both addresses are counted up
                ;
                lda r1+0
                sta reu_c64base
                lda r1+1
                sta reu_c64base + 1
                ;
                lda r0+0
                sta reu_reubase
                lda r0+1
                sta reu_reubase + 1
                lda r0+2
                sta reu_reubase + 2
                ;
                lda r2
                sta reu_translen
                lda r2 + 1
                sta reu_translen + 1
                lda #%10010000;  c64 -> REU with immediate execution
                sta reu_command
                rts

;----------------------------------------------------------------------------
;
;       movereutoram
;       ------------
;
;       Usage:
;
;       movereutoram( offsetreu offsetram length );
;
;       See: moveramtoreu
;
;----------------------------------------------------------------------------
movereutoram    lda #0
                sta reu_control ; to make sure both addresses are counted up
                ;
                lda r1+0
                sta reu_c64base
                lda r1+1
                sta reu_c64base + 1
                ;
                lda r0+0
                sta reu_reubase
                lda r0+1
                sta reu_reubase + 1
                lda r0+2
                sta reu_reubase + 2
                ;
                lda r2
                sta reu_translen
                lda r2 + 1
                sta reu_translen + 1
                lda #%10010001;  REU -> c64 with immediate execution
                sta reu_command
                rts
;----------------------------------------------------------------------------
