;
; MTASK's Include File for Applications v0.0.1
;

; Task mode const's
dead=0
worker=1
idler=2

; Base Kernel
kernel=         $8000
; Kernel Calls
install=        kernel+$00*3
engine=         kernel+$01*3
irq=            kernel+$02*3
load=           kernel+$03*3
save=           kernel+$04*3
calstrlen=      kernel+$05*3
printstr=       kernel+$06*3
clrscr=         kernel+$07*3
getch=          kernel+$08*3
putch=          kernel+$09*3
getprstate=     kernel+$0a*3
setprstate=     kernel+$0b*3
getprsleepie=   kernel+$0c*3
setprsleepie=   kernel+$0d*3
gets=           kernel+$0e*3
puts=           kernel+$0f*3
reservestdright=kernel+$10*3
releasestdright=kernel+$11*3
workmode=       kernel+$12*3
idlemode=       kernel+$13*3
suicide=        kernel+$14*3
spawn=          kernel+$15*3
kill=           kernel+$16*3
getworkers=     kernel+$17*3
getidlers=      kernel+$18*3
getdead=        kernel+$19*3
phex16=         kernel+$1a*3
phex4=          kernel+$1b*3
horsepower=     kernel+$1c*3
csup=           kernel+$1d*3
cntarg=         kernel+$1e*3
seekarg=        kernel+$1f*3
dset=           kernel+$20*3
dopen=          kernel+$21*3
dclose=         kernel+$22*3
dget=           kernel+$23*3
dput=           kernel+$24*3
dsetread=       kernel+$25*3
dsetwrite=      kernel+$26*3
dinit=          kernel+$27*3
calstrlen2=     kernel+$28*3
dname=          kernel+$29*3
waitnokey=      kernel+$2a*3
getpridenty=    kernel+$2b*3
setpridenty=    kernel+$2c*3

; SYSTEM VARIABLES (Critical!)
kflag=$028d ; KEYBOARD FLAG
stdin=$9e00 ; STDIN buffer
stderr=$9f00 ; Error buffer
stderro=$9fff ; STDERRO - Buffer owner(Value=PID)
pristd=$03fb ; PRIMARY STD CASING :
             ; If this variable is set then
             ; all STD routines will be executed
             ; in non task switchable mode.
             ; (If multitasking is slowing down one single process,
             ;  then it is possible to set this variable to
             ;  make screen output look smoother).
stdright=$03fc ; Don't set manually!(0=Rights not reserved,
               ; !=thread id that has reserved the std IN/OUT rights.)
curtask=$03fd ; Currently running task
action=$03fe
alts=$03ff ;Allow task switch (0=False, 1=True)
delayv=16 ; This value sets the frequence of task scheduling,
          ; smaller value = quicker
          ; larger value = slower
          ; Quicker means that more CPU power will be reserved for
          ; task switching.(Default 16 is just fine)
          ; Too small values(like 1-8) may jam the processor on
          ; C64's without SCPU or any other speeder.
maxtasks=15 ; Valid values = 1,3,7,15,...
            ; 1=2, 3=4, 7=8, 15=16, .. (acts like AND)

*=$0800
.word main ;Start jumpy address

;
; 
;       SHELL version 0.0.1 for JTMOS(MTASK KERNEL)
;
;
                                ; Wake up! It's morning, sun is shining!
main                            jsr workmode
                                ;
                                lda #0
                                jsr print
                                ;
main_l1                         nop
                                ; *** PROMPT FOR COMMAND ***
                                ;
                                jsr reservestdright

                                ;
                                lda curtask
                                asl
                                tax
                                lda #<id_shell
                                ldy #>id_shell
                                jsr setpridenty
                                
                                ;
                                lda #1
                                jsr print
                                ldx #<stdin
                                ldy #>stdin
                                jsr gets
                                lda #13
                                jsr putch
                                ;
                                jsr strip2cname
                                ;
                                ldx #<cmdname
                                ldy #>cmdname
                                jsr puts

                                ; Clear load space
                                jsr clearloadsp
                                ; *** ATTEMPT TO LOAD COMMAND ***
                                ldx #<cmdname
                                ldy #>cmdname
                                jsr load
                                bcc main_l2
                                ; ON ERROR
main_l3                         lda #"?"
                                jsr putch
                                lda #13
                                jsr putch
                                jmp main_l1

                                ; Get start address
main_l2                         lda #$00
                                ldx #$20
                                sta $38
                                stx $39
                                ldy #0
                                lda ($38),y
                                iny
                                lda ($38),y
                                iny
                                lda ($38),y
                                sta pid_start+0
                                iny
                                lda ($38),y
                                sta pid_start+1

                                ;
                                lda #13
                                jsr putch


                                ; *** RUN THE APPLICATION ***
                                ; Sleep shell thread until child returns.
                                jsr idlemode
                                jsr releasestdright
                                ;
                                ldx pid_start+0
                                ldy pid_start+1
                                jsr spawn
                                bne main_l3
                                stx child_pid
                                ;
                                jsr waitchilddead
                                ;
                                jsr checkstderr

                                ; *** CHILD PROCESS COMPLETED ***
                                ; - Back to work mode when shell is
                                ;   again needed.
                                jsr workmode

                                jmp main_l1

; This function waits until child makes suicide.(Oh fashioning isn't it?? ;)
; (In computer terms, of course!)
waitchilddead                   nop
                                ; Specified system stop key pressed?
                                jsr stopkey
                                cmp #0
                                bne stop
                                ; Child process ended its running?(killed)
                                ldx child_pid
                                jsr getprstate
                                cmp #dead
                                bne waitchilddead
                                rts

stopkey                         lda kflag
                                and #(1+4)
                                rts

stop                            ldx child_pid
                                jsr kill
                                lda #3
                                jmp print


print                           asl
                                tax
                                lda ptab,x
                                pha
                                lda ptab+1,x
                                tay
                                pla
                                tax
                                jmp puts

pid_start                       .word 0
child_pid                       .byte 0

ptab                            .word t00,t01,t02,t03

t00                             .text "tiny shell 0.0.2 by jari tapio tuominen."
                                .byte 13,0

t01                             .text "#"
                                .byte 0

t02                             .text "new data arrived at stderr."
                                .byte 13
                                .text "stderr : "
                                .byte 0

t03                             .text "?process terminated by user request."
                                .byte 13,0

cmdname                         .text "                                "
                                ;^^Shouldn't be larger than that..

strip2cname                     ldx #0
stripl                          lda stdin,x
                                cmp #0
                                beq stripz
                                cmp #$20
                                beq stripz
                                sta cmdname,x
                                inx
                                bne stripl
stripz                          lda #0
                                sta cmdname,x
                                rts
;-----------------------------------------------------------------------
checkstderr                     lda stderr
                                bne checkstrerr_l1
                                rts
checkstrerr_l1                  lda #2
                                jsr puts
                                ldx #<stderr
                                ldy #>stderr
                                jsr puts
                                lda #13
                                jsr putch
                                lda #0
                                sta stderr
                                rts
;-----------------------------------------------------------------------
clearloadsp                     lda #0  ; BRK opcode at
                                        ; $2000,
                                        ; so if program isn't loaded at
                                        ; $2000, it'll however atleast
                                        ; tell user by sigbrk that
                                        ; program isn't suitable for
                                        ; execution on this system.
                                sta $2000
                                rts
;-----------------------------------------------------------------------
id_shell                        .text "shell"
                                .byte 0
;-----------------------------------------------------------------------
