;
; MTASK's Include File for Applications v0.0.1
;

; Task mode const's
dead=0
worker=1
idler=2

; Base Kernel
kernel=   $8000
; Kernel Calls
install=        kernel+$00*3
engine=         kernel+$01*3
irq=            kernel+$02*3
load=           kernel+$03*3
save=           kernel+$04*3
calstrlen=      kernel+$05*3
printstr=       kernel+$06*3
clrscr=         kernel+$07*3
getch=          kernel+$08*3
putch=          kernel+$09*3
getprstate=     kernel+$0a*3
setprstate=     kernel+$0b*3
getprsleepie=   kernel+$0c*3
setprsleepie=   kernel+$0d*3
gets=           kernel+$0e*3
puts=           kernel+$0f*3
reservestdright=kernel+$10*3
releasestdright=kernel+$11*3
workmode=       kernel+$12*3
idlemode=       kernel+$13*3
suicide=        kernel+$14*3
spawn=          kernel+$15*3
kill=           kernel+$16*3
getworkers=     kernel+$17*3
getidlers=      kernel+$18*3
getdead=        kernel+$19*3
phex16=         kernel+$1a*3
phex4=          kernel+$1b*3
horsepower=     kernel+$1c*3

; SYSTEM VARIABLES (Critical!)
stderr=$9f00
stderro=$9fff ; STDERRO - Buffer owner(Value=PID)
icallfreq=$3f4 ; Interrupt Calling Frequency(16bit value)
pristd=$03fb ; PRIMARY STD CASING :
             ; If this variable is set then
             ; all STD routines will be executed
             ; in non task switchable mode.
             ; (If multitasking is slowing down one single process,
             ;  then it is possible to set this variable to
             ;  make screen output look smoother).
stdright=$03fc ; Don't set manually!(0=Rights not reserved,
               ; !=thread id that has reserved the std IN/OUT rights.)
curtask=$03fd ; Currently running task
action=$03fe
alts=$03ff ;Allow task switch (0=False, 1=True)
delayv=16 ; This value sets the frequence of task scheduling,
          ; smaller value = quicker
          ; larger value = slower
          ; Quicker means that more CPU power will be reserved for
          ; task switching.(Default 16 is just fine)
          ; Too small values(like 1-8) may jam the processor on
          ; C64's without SCPU or any other speeder.
maxtasks=15 ; Valid values = 1,3,7,15,...
            ; 1=2, 3=4, 7=8, 15=16, .. (acts like AND)

*=$2000 ; I am aiming to keep the SHELL in $0800-$1fff memory region.
        ; So I can load applications at $2000-$6fff
.text "mz"
.word main ;Start jumpy address

;
;       SYSINFO - Gives information about system state, etc.
;
main                    nop
                        ;
                        ; *** START UP CODE ***
                        ; - Allocate needed resources
                        jsr reservestdright

                        ; Action :
                        lda #0
                        jsr print
                        ;
                        lda #6
                        jsr print
                        ldx icallfreq
                        lda icallfreq+1
                        jsr phex16
                        lda #13
                        jsr putch
                        ;
                        lda #1
                        jsr print
                        ;
                        lda #2
                        jsr print
                        jsr getworkers
                        tya
                        tax
                        lda #0
                        jsr phex16
                        lda #13
                        jsr putch
                        ;
                        lda #3
                        jsr print
                        jsr getidlers
                        tya
                        tax
                        lda #0
                        jsr phex16
                        lda #13
                        jsr putch
                        ;
                        lda #4
                        jsr print
                        jsr getdead
                        tya
                        tax
                        lda #0
                        jsr phex16
                        lda #13
                        jsr putch
                        ;
                        lda #5
                        jsr print
                        jsr horsepower
                        tya
                        jsr phex16
                        lda #13
                        jsr putch
                        ;
                        lda #0
                        sta var1
main_l1                 ldx var1
                        jsr getprstate
                        tax
                        lda #0
                        jsr phex16
                        lda #","
                        jsr putch
                        inc var1
                        lda var1
                        cmp #16
                        bne main_l1
                        lda #$14
                        jsr putch
                        lda #13
                        jsr putch


                        ;
                        ; *** PROCESS END CODE ***
                        ; - Release allocated resources
                        jsr releasestdright
                        ;
                        jmp suicide

print                           asl
                                tax
                                lda ptab,x
                                pha
                                lda ptab+1,x
                                tay
                                pla
                                tax
                                jmp puts

var1                            .byte 0

ptab                            .word t00,t01,t02,t03,t04,t05,t06

t00                             .text "system info program 0.0.1"
                                .byte 13,0

t01                             .text "* processes currently registered *"
                                .byte 13
                                .byte 0

t02                             .text "workers: "
                                .byte 0
   
t03                             .text "idlers: "
                                .byte 0

t04                             .text "dead: "
                                .byte 0

t05                             .text "horsepower(cpu): "
                                .byte 0

t06                             .text "interrupt calling "
                                .text "frequency: "
                                .byte 0
